
//+------------------------------------------------------------------+
//| Pending Order Counts and Tickets                                 |
//+------------------------------------------------------------------+

class CPending
{
	private:
		void OrderCount(string pSymbol);
		int BuyLimitCount, SellLimitCount, BuyStopCount, SellStopCount, BuyStopLimitCount, SellStopLimitCount, TotalPendingCount;
		ulong PendingTickets[];
		
	public:
		int TotalPending(string pSymbol);
		void GetTickets(string pSymbol, ulong &pTickets[]);
};

int totalPendingOrders;
ulong ticketOrderNumbers[];
CPending pendingOrders;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{

   return (INIT_SUCCEEDED);
}

//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   
}

//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick() {

   // Test Get Order Ticket Numbers for Pending Orders
   totalPendingOrders = pendingOrders.TotalPending(_Symbol);
   Print("Total Pending Orders: " + totalPendingOrders);
   
   Print(ArraySize(ticketOrderNumbers));
   
   if(ArrayResize(ticketOrderNumbers, totalPendingOrders+1)<0) {
      PrintFormat("ArrayResize of ticketOrderNumbers failed. Error: %d", GetLastError());

   }
      
   for (int i=0; i<totalPendingOrders-1; i++) {
      Print("Ticket Order Number: " + ticketOrderNumbers[i]);

   }
   
   Print(ArraySize(ticketOrderNumbers));
}

//---

// Internal function to count orders and collect ticket numbers
void CPending::OrderCount(string pSymbol)
{
	BuyLimitCount = 0; SellLimitCount = 0; BuyStopCount = 0; SellStopCount = 0; BuyStopLimitCount = 0; SellStopLimitCount = 0; TotalPendingCount = 0;
	
	ArrayResize(PendingTickets, 1);
	ArrayInitialize(PendingTickets, 0);
	
	for(int i = 0; i < OrdersTotal(); i++)
	{
		ulong ticket = OrderGetTicket(i);
		if(OrderGetString(ORDER_SYMBOL) == pSymbol)
		{
			long type = OrderGetInteger(ORDER_TYPE);
			
			switch((int)type)
			{
				case ORDER_TYPE_BUY_STOP:
				BuyStopCount++; break;
				
				case ORDER_TYPE_SELL_STOP:
				SellStopCount++; break;
				
				case ORDER_TYPE_BUY_LIMIT:
				BuyLimitCount++; break;
				
				case ORDER_TYPE_SELL_LIMIT:
				SellLimitCount++; break;
				
				case ORDER_TYPE_BUY_STOP_LIMIT:
				BuyStopLimitCount++; break;
				
				case ORDER_TYPE_SELL_STOP_LIMIT:
				SellStopLimitCount++; break;
			}
			
			TotalPendingCount++;
			
			ArrayResize(PendingTickets,TotalPendingCount);
			PendingTickets[ArraySize(PendingTickets)-1] = ticket;
		}
	}
}

// Total Pending
int CPending::TotalPending(string pSymbol)
{
	OrderCount(pSymbol);
	return(TotalPendingCount);
}

